// auto generated by cdgen, 2019.05.1 on Wednesday Jun 12 @ 6:40PM
// source file: database/config.json

/*
 * This is free and unencumbered software released into the public
 * domain.
 *
 * Anyone is free to copy, modify, publish, use, compile, sell, or
 * distribute this software, either in source code form or as a compiled
 * binary, for any purpose, commercial or non-commercial, and by any
 * means.
 *
 * The complete license can be found in the UNLICENSE file.
 *
 * Vim:
 * set foldmethod=marker
 * set shiftwidth=2
 * set smartcase
 * set tabstop=2
 */

package config

import (
	"database/sql"
	"encoding/json"
	"errors"
	"fmt"
)

import (
	// database drivers
	_ "github.com/lib/pq"
	_ "github.com/mattn/go-sqlite3"
)

var errNoConnectionOrTransaction = errors.New("error: a database connection or transaction must be provided")

// Config models the table config
type Config struct {
	Sitename   string `json:"sitename"`
	Dbfile     string `json:"dbfile"`
	Port       string `json:"port"`
	Cookiename string `json:"cookiename"`
	Copyright  string `json:"copyright"`

	tablename string
	adhoc     string
	debug     bool
	where     *Config
	order     string
	db        *sql.DB
	tx        *sql.Tx
}

// New ...
func New() *Config {
	return &Config{
		Sitename:   "",
		Dbfile:     "",
		Port:       "",
		Cookiename: "",
		Copyright:  "",
		tablename:  "config",
		adhoc:      "",
	}
}

// ToJSON ...
func (x *Config) ToJSON() (data []byte, err error) {
	data, err = json.Marshal(x)
	return
}

// Parse ...
func (x *Config) Parse(data []byte) (err error) {
	err = json.Unmarshal(data, x)
	return
}

// String ...
func (x *Config) String() string {
	out := "---\n"
	out += fmt.Sprintf("sitename: %v", x.Sitename) + "\n"
	out += fmt.Sprintf("dbfile: %v", x.Dbfile) + "\n"
	out += fmt.Sprintf("port: %v", x.Port) + "\n"
	out += fmt.Sprintf("cookiename: %v", x.Cookiename) + "\n"
	out += fmt.Sprintf("copyright: %v", x.Copyright) + "\n"

	return out
}

// Tablename ...
func (x *Config) Tablename(tablename string) *Config {
	x.tablename = tablename
	return x
}

// Adhoc ...
func (x *Config) Adhoc(clause string) *Config {
	x.adhoc = clause
	return x
}

// Where ...
func (x *Config) Where(where *Config) *Config {
	x.where = where
	return x
}

// Debug ...
func (x *Config) Debug(debug bool) *Config {
	x.debug = debug
	return x
}

// Order ...
func (x *Config) Order(order string) *Config {
	x.order = order
	return x
}

// Db ...
func (x *Config) Db(db *sql.DB) *Config {
	x.db = db
	return x
}

// Tx ...
func (x *Config) Tx(tx *sql.Tx) *Config {
	x.tx = tx
	return x
}

// Create ...
func (x *Config) Create() (rowcnt int64, err error) {
	if x.db == nil && x.tx == nil {
		err = errNoConnectionOrTransaction
		return
	}
	query := "INSERT INTO config (sitename, dbfile, port, cookiename, copyright) VALUES (?, ?, ?, ?, ?)"

	if x.debug {
		fmt.Println("--- DEBUG ---")
		fmt.Println(query)
		fmt.Println(x)
		fmt.Println("--- DEBUG ---")
	}

	var result sql.Result
	if x.db != nil {
		result, err = x.db.Exec(query, &x.Sitename, &x.Dbfile, &x.Port, &x.Cookiename, &x.Copyright)
		if err != nil {
			return
		}
	} else {
		result, err = x.tx.Exec(query, &x.Sitename, &x.Dbfile, &x.Port, &x.Cookiename, &x.Copyright)
		if err != nil {
			return
		}
	}
	rowcnt, err = result.RowsAffected()
	if err != nil {
		return
	}

	return
}

// Read ...
func (x *Config) Read() (configs []Config, err error) {
	if x.db == nil && x.tx == nil {
		err = errNoConnectionOrTransaction
		return
	}
	query := "SELECT sitename, dbfile, port, cookiename, copyright FROM " + x.tablename

	cnt := 0
	tmpSlice := make([]interface{}, 99)
	whereClause := ""

	if len(x.adhoc) > 0 {
		whereClause = x.adhoc
	}

	if x.where != nil {

		if len(string(x.where.Sitename)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "sitename = ?"
			tmpSlice = append(tmpSlice, x.where.Sitename)
			cnt++
		}

		if len(string(x.where.Dbfile)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "dbfile = ?"
			tmpSlice = append(tmpSlice, x.where.Dbfile)
			cnt++
		}

		if len(string(x.where.Port)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "port = ?"
			tmpSlice = append(tmpSlice, x.where.Port)
			cnt++
		}

		if len(string(x.where.Cookiename)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "cookiename = ?"
			tmpSlice = append(tmpSlice, x.where.Cookiename)
			cnt++
		}

		if len(string(x.where.Copyright)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "copyright = ?"
			tmpSlice = append(tmpSlice, x.where.Copyright)
			cnt++
		}

	}

	args := make([]interface{}, cnt)
	if len(whereClause) > 0 {
		idx := 0
		for _, arg := range tmpSlice {
			if arg != nil {
				args[idx] = arg
				idx++
			}
		}
		query += fmt.Sprintf(" WHERE %v", whereClause)
	}

	if len(x.order) > 0 {
		query += fmt.Sprintf(" ORDER BY %v", x.order)
	}

	if x.debug {
		fmt.Println("--- DEBUG ---")
		fmt.Println(query)
		fmt.Println(args)
		fmt.Println("--- DEBUG ---")
	}

	var rows *sql.Rows
	if x.db != nil {
		rows, err = x.db.Query(query, args...)
		defer rows.Close()
	} else {
		rows, err = x.tx.Query(query, args...)
		defer rows.Close()
	}
	if err != nil {
		return
	}

	for rows.Next() {
		var obj Config
		rows.Scan(&obj.Sitename, &obj.Dbfile, &obj.Port, &obj.Cookiename, &obj.Copyright)
		configs = append(configs, obj)
	}

	return
}

// Update ...
func (x *Config) Update() (rowcnt int64, err error) {
	if x.db == nil && x.tx == nil {
		err = errNoConnectionOrTransaction
		return
	}
	query := "UPDATE config SET "

	cnt1, cnt2 := 0, 0
	tmpSlice1 := make([]interface{}, 50)
	tmpSlice2 := make([]interface{}, 50)

	if len(string(x.Sitename)) > 0 || x.Sitename == "DB::NULL" {
		if cnt1 > 0 {
			query += ", "
		}
		if x.Sitename == "DB::NULL" {
			x.Sitename = ""
		}
		query += "sitename = ?"
		tmpSlice1 = append(tmpSlice1, x.Sitename)
		cnt1++
	}

	if len(string(x.Dbfile)) > 0 || x.Dbfile == "DB::NULL" {
		if cnt1 > 0 {
			query += ", "
		}
		if x.Dbfile == "DB::NULL" {
			x.Dbfile = ""
		}
		query += "dbfile = ?"
		tmpSlice1 = append(tmpSlice1, x.Dbfile)
		cnt1++
	}

	if len(string(x.Port)) > 0 || x.Port == "DB::NULL" {
		if cnt1 > 0 {
			query += ", "
		}
		if x.Port == "DB::NULL" {
			x.Port = ""
		}
		query += "port = ?"
		tmpSlice1 = append(tmpSlice1, x.Port)
		cnt1++
	}

	if len(string(x.Cookiename)) > 0 || x.Cookiename == "DB::NULL" {
		if cnt1 > 0 {
			query += ", "
		}
		if x.Cookiename == "DB::NULL" {
			x.Cookiename = ""
		}
		query += "cookiename = ?"
		tmpSlice1 = append(tmpSlice1, x.Cookiename)
		cnt1++
	}

	if len(string(x.Copyright)) > 0 || x.Copyright == "DB::NULL" {
		if cnt1 > 0 {
			query += ", "
		}
		if x.Copyright == "DB::NULL" {
			x.Copyright = ""
		}
		query += "copyright = ?"
		tmpSlice1 = append(tmpSlice1, x.Copyright)
		cnt1++
	}

	whereClause := ""

	if len(x.adhoc) > 0 {
		whereClause = x.adhoc
	}

	if x.where != nil {

		if len(string(x.where.Sitename)) > 0 {
			if cnt2 > 0 {
				whereClause += " AND "
			}
			whereClause += "sitename = ?"
			tmpSlice2 = append(tmpSlice2, x.where.Sitename)
			cnt2++
		}

		if len(string(x.where.Dbfile)) > 0 {
			if cnt2 > 0 {
				whereClause += " AND "
			}
			whereClause += "dbfile = ?"
			tmpSlice2 = append(tmpSlice2, x.where.Dbfile)
			cnt2++
		}

		if len(string(x.where.Port)) > 0 {
			if cnt2 > 0 {
				whereClause += " AND "
			}
			whereClause += "port = ?"
			tmpSlice2 = append(tmpSlice2, x.where.Port)
			cnt2++
		}

		if len(string(x.where.Cookiename)) > 0 {
			if cnt2 > 0 {
				whereClause += " AND "
			}
			whereClause += "cookiename = ?"
			tmpSlice2 = append(tmpSlice2, x.where.Cookiename)
			cnt2++
		}

		if len(string(x.where.Copyright)) > 0 {
			if cnt2 > 0 {
				whereClause += " AND "
			}
			whereClause += "copyright = ?"
			tmpSlice2 = append(tmpSlice2, x.where.Copyright)
			cnt2++
		}

	}

	args := make([]interface{}, cnt1+cnt2)
	if len(whereClause) > 0 {
		idx := 0
		for _, arg := range tmpSlice1 {
			if arg != nil {
				args[idx] = arg
				idx++
			}
		}
		for _, arg := range tmpSlice2 {
			if arg != nil {
				args[idx] = arg
				idx++
			}
		}
		query += fmt.Sprintf(" WHERE %v", whereClause)
	}

	if x.debug {
		fmt.Println("--- DEBUG ---")
		fmt.Println(query)
		fmt.Println(args)
		fmt.Println("--- DEBUG ---")
	}

	var result sql.Result
	if x.db != nil {
		result, err = x.db.Exec(query, args...)
		if err != nil {
			return
		}
	} else {
		result, err = x.tx.Exec(query, args...)
		if err != nil {
			return
		}
	}
	rowcnt, err = result.RowsAffected()
	if err != nil {
		return
	}

	return
}

// Delete ...
func (x *Config) Delete() (rowcnt int64, err error) {
	if x.db == nil && x.tx == nil {
		err = errNoConnectionOrTransaction
		return
	}
	query := "DELETE FROM config"

	cnt := 0
	tmpSlice := make([]interface{}, 99)
	whereClause := ""

	if len(x.adhoc) > 0 {
		whereClause = x.adhoc
	}

	if x.where != nil {

		if len(string(x.where.Sitename)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "sitename = ?"
			tmpSlice = append(tmpSlice, x.where.Sitename)
			cnt++
		}

		if len(string(x.where.Dbfile)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "dbfile = ?"
			tmpSlice = append(tmpSlice, x.where.Dbfile)
			cnt++
		}

		if len(string(x.where.Port)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "port = ?"
			tmpSlice = append(tmpSlice, x.where.Port)
			cnt++
		}

		if len(string(x.where.Cookiename)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "cookiename = ?"
			tmpSlice = append(tmpSlice, x.where.Cookiename)
			cnt++
		}

		if len(string(x.where.Copyright)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "copyright = ?"
			tmpSlice = append(tmpSlice, x.where.Copyright)
			cnt++
		}

	}

	args := make([]interface{}, cnt)
	if len(whereClause) > 0 {
		idx := 0
		for _, arg := range tmpSlice {
			if arg != nil {
				args[idx] = arg
				idx++
			}
		}
		query += fmt.Sprintf(" WHERE %v", whereClause)
	}

	if x.debug {
		fmt.Println("--- DEBUG ---")
		fmt.Println(query)
		fmt.Println(args)
		fmt.Println("--- DEBUG ---")
	}

	var result sql.Result
	if x.db != nil {
		result, err = x.db.Exec(query, args...)
		if err != nil {
			return
		}
	} else {
		result, err = x.tx.Exec(query, args...)
		if err != nil {
			return
		}
	}
	rowcnt, err = result.RowsAffected()
	if err != nil {
		return
	}

	return
}

// Count ...
func (x *Config) Count() (rowcnt int64, err error) {
	if x.db == nil && x.tx == nil {
		err = errNoConnectionOrTransaction
		return
	}
	query := "SELECT COUNT(*) FROM config"

	cnt := 0
	tmpSlice := make([]interface{}, 99)
	whereClause := ""

	if len(x.adhoc) > 0 {
		whereClause = x.adhoc
	}

	if x.where != nil {

		if len(string(x.where.Sitename)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "sitename = ?"
			tmpSlice = append(tmpSlice, x.where.Sitename)
			cnt++
		}

		if len(string(x.where.Dbfile)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "dbfile = ?"
			tmpSlice = append(tmpSlice, x.where.Dbfile)
			cnt++
		}

		if len(string(x.where.Port)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "port = ?"
			tmpSlice = append(tmpSlice, x.where.Port)
			cnt++
		}

		if len(string(x.where.Cookiename)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "cookiename = ?"
			tmpSlice = append(tmpSlice, x.where.Cookiename)
			cnt++
		}

		if len(string(x.where.Copyright)) > 0 {
			if cnt > 0 {
				whereClause += " AND "
			}
			whereClause += "copyright = ?"
			tmpSlice = append(tmpSlice, x.where.Copyright)
			cnt++
		}

	}

	args := make([]interface{}, cnt)
	if len(whereClause) > 0 {
		idx := 0
		for _, arg := range tmpSlice {
			if arg != nil {
				args[idx] = arg
				idx++
			}
		}
		query += fmt.Sprintf(" WHERE %v", whereClause)
	}

	if x.debug {
		fmt.Println("--- DEBUG ---")
		fmt.Println(query)
		fmt.Println(args)
		fmt.Println("--- DEBUG ---")
	}

	var row *sql.Row
	if x.db != nil {
		row = x.db.QueryRow(query, args...)
	} else {
		row = x.tx.QueryRow(query, args...)
	}
	if err != nil {
		return
	}

	row.Scan(&rowcnt)

	return
}
